django/diplomas/urls.py
from django.urls import path
from . import views

app_name = 'diplomas'

urlpatterns = [
    path('', views.index, name='index'),
    path('speciality/<int:speciality_id>', views.speciality, name='speciality'),
    path('tag/<int:tag_id>', views.tag, name='tag'),
    path('search', views.search, name="search"),
]

django/ippo/urls.py
from django.conf.urls import url, include
from django.contrib import admin
from django.urls import path
from django.conf import settings
from django.conf.urls.static import static
from django.views.generic import RedirectView
from documents.views import protected_view
from ecm.views import protected_view as ecm_view
from django.views.static import serve

urlpatterns = [
                  url(r'^favicon\.ico$', RedirectView.as_view(url='/static/main/images/ippo.ico')),
                  path('admin/', admin.site.urls),
                  path('', include('main.urls')),
                  path('diplomas/', include('diplomas.urls')),
                  path('appointments/', include('appointment.urls')),
                  path('news/', include('news.urls')),
                  url(r'^ckeditor/', include('ckeditor_uploader.urls')),
                  path('subjects/', include('subjects.urls')),
                  path('documents/', include('documents.urls')),
                  path('schedule/', include('schedule.urls')),
                  path('people/', include('people.urls')),
                  path('library/', include('library.urls')),
                  url(r'^select2/', include('django_select2.urls')),
              ] + static(
    settings.STATIC_URL,
    document_root=settings.STATIC_ROOT
) + static(
    settings.MEDIA_URL,
    document_root=settings.MEDIA_ROOT
)
#
# if settings.DEBUG:
#     urlpatterns += [
#         url(
#             r"^{}/(?P<path>.*)$".format(settings.MEDIA_URL),
#             serve,
#             {"document_root": settings.MEDIA_ROOT, "show_indexes": True}
#         ),
#         url(
#             r"^{}/(?P<path>.*)$".format(settings.PROTECTED_MEDIA_URL),
#             serve,
#             {"document_root": settings.PROTECTED_MEDIA_ROOT, "show_indexes": True}
#         ),
#     ]
# else:
urlpatterns += [
    # url(
    #     r"^{}/(?P<path>.*)$".format(settings.PROTECTED_MEDIA_URL),
    #     protected_view
    # ),
    url(r'^protected/ecm/(?P<path>.*)$', ecm_view),
    url(r'^protected/(?P<path>.*)$', protected_view),
]

django/library/urls.py
from django.urls import path
from . import views

app_name = 'library'

urlpatterns = [
    path('', views.index, name='index'),
    path('tag/<int:tag_id>', views.works_with_tags, name='works_with_tags'),
]

django/main/urls.py
from django.urls import path
from . import views

app_name = 'main'

urlpatterns = [
    path('', views.index, name="home"),
    path('about-<str:sub_cat>', views.about, name="about"),
    path('feedback', views.feedback, name="feedback"),
    path('teacher/<int:teacher_id>', views.about_teacher, name="teacher"),
    path('worker/<int:worker_id>', views.about_worker, name="worker"),
]

django/news/urls.py
from django.urls import path

from . import views

app_name = 'news'

urlpatterns = [
    path('', views.index, name="index"),
    path('<str:slug>', views.post, name="post"),
    path('tag/<str:slug>', views.tag, name="tag"),
]

django/people/urls.py
from django.urls import path

from . import views

app_name = 'people'
urlpatterns = [
    path('profile/', views.profile, name="profile"),
    path('profile/loads/<int:rate_id>/', views.rate_loads, name="rate_loads"),
    path('profile/loads/add/<int:rate_id>/<int:category>/', views.edit_load, name="add_load"),
    path('profile/loads/edit/<int:rate_id>/<int:category>/<int:load_id>/', views.edit_load, name="edit_load"),
    path('profile/load/delete/<int:load_id>/', views.delete_load, name="delete_load"),
    path('profile/load/names_list/', views.names_list),
    path('profile/loads/export/', views.export_loads, name="export_loads"),
    path('semester/<int:semester_id>/', views.semester, name="semester"),
    path('semester/<int:semester_id>/<str:period_category>/', views.semester_table),
    path('set_mark/', views.set_mark, name="set_mark"),
    path('parse_students/', views.parse_students, name='parse_students'),

]

django/main/models.py
from django.utils.text import slugify as django_slugify

alphabet = {'а': 'a', 'б': 'b', 'в': 'v', 'г': 'g', 'д': 'd', 'е': 'e', 'ё': 'yo', 'ж': 'zh', 'з': 'z', 'и': 'i',
            'й': 'j', 'к': 'k', 'л': 'l', 'м': 'm', 'н': 'n', 'о': 'o', 'п': 'p', 'р': 'r', 'с': 's', 'т': 't',
            'у': 'u', 'ф': 'f', 'х': 'kh', 'ц': 'ts', 'ч': 'ch', 'ш': 'sh', 'щ': 'shch', 'ы': 'i', 'э': 'e', 'ю': 'yu',
            'я': 'ya'}


def my_slugify(s):
    return django_slugify(''.join(alphabet.get(w, w) for w in s.lower()))

django/main/forms.py
from django import forms
from captcha.fields import ReCaptchaField
from captcha.widgets import ReCaptchaV2Checkbox


class FeedbackForm(forms.Form):
    subject = forms.ChoiceField(label='Тема', choices=[
        ('problem', 'Проблема'),
        ('suggestion', 'Предложение'),
        ('other', 'Другое')
    ], widget=forms.Select(attrs={'class': 'form-control'}))
    message = forms.CharField(label='Сообщение', max_length=1024,
                              widget=forms.Textarea(attrs={'class': 'form-control', 'rows': 3}))
    captcha = ReCaptchaField(widget=ReCaptchaV2Checkbox(
        api_params={'hl': 'ru'}
    ))

django/main/views.py
from datetime import datetime

from django.conf import settings
from django.contrib import messages
from django.core.mail import EmailMessage
from django.http import HttpResponseRedirect
from django.shortcuts import render, get_object_or_404, Http404

from documents.models import Document
from news.models import Post
from people.models import Teacher, Worker
from .forms import FeedbackForm


def index(request):
    posts_list = Post.objects.filter(pub_date_time__lte=datetime.now())[:3]
    context = {
        'posts_list': posts_list,
    }
    return render(request, 'main/index.html', context)


def about(request, sub_cat):
    if sub_cat == 'today':
        today = get_object_or_404(Document, name='Кафедра сегодня').description
        return render(request, 'main/about_today.html', {'today': today})
    elif sub_cat == 'history':
        history = get_object_or_404(Document, name='История кафедры').description
        return render(request, 'main/about_history.html', {'history': history})
    elif sub_cat == 'workers':
        teachers = Teacher.objects.filter(departament__name='ИиППО')
        workers = Worker.objects.filter(departament__name='ИиППО', teacher__isnull=True)
        context = {
            'teachers': teachers,
            'workers': workers,
        }
        return render(request, 'main/about_workers.html', context)
    else:
        return Http404


def about_teacher(request, teacher_id):
    teacher = get_object_or_404(Teacher, id=teacher_id)
    subjects = teacher.subjects

    context = {
        'teacher': teacher,
    }
    return render(request, 'main/teacher.html', context)


def about_worker(request, worker_id):
    worker = get_object_or_404(Worker, id=worker_id)

    context = {
        'worker': worker,
    }
    return render(request, 'main/worker.html', context)


def feedback(request):
    if request.method == 'POST':
        form = FeedbackForm(request.POST)
        if form.is_valid():
            to = [settings.EMAIL_FEEDBACK_ADDRESS]
            subject = form.cleaned_data['subject']
            message = form.cleaned_data['message']
            email = EmailMessage(subject, message, to=to)
            email.send()
            messages.add_message(request, messages.SUCCESS, 'Сообщение отправлено')
            return HttpResponseRedirect('/')
    else:
        form = FeedbackForm()
    return render(request, 'main/feedback.html', {'form': form})

django/main/templates/main/about_history.html
{% extends 'main/base.html' %}
{% load static %}
{% block title %}{{ "История кафедры" }}{% endblock %}
{% load django_bootstrap_breadcrumbs %}
{% block breadcrumbs %}
  {{ block.super }}
  {% breadcrumb "История кафедры" "/about-history" %}
{% endblock %}
{% block content %}
  {% render_breadcrumbs %}
  <section class="container-fluid flex-grow">
    <div class="container">
        {{ history|safe }}
    </div>
  </section>
{% endblock %}

django/main/templates/main/about_today.html
{% extends 'main/base.html' %}
{% load static %}
{% block title %}{{ "Кафедра сегодня" }}{% endblock %}
{% load django_bootstrap_breadcrumbs %}
{% block breadcrumbs %}
  {{ block.super }}
  {% breadcrumb "Кафедра сегодня" "/about-today" %}
{% endblock %}
{% block content %}
  {% render_breadcrumbs %}
  <section class="container-fluid flex-grow">
    <div class="container">
        {{ today|safe }}
    </div>
  </section>
{% endblock %}

django/main/templates/main/about_workers.html
{% extends 'main/base.html' %}
{% load static %}
{% block title %}{{ "Сотрудники кафедры" }}{% endblock %}
{% load django_bootstrap_breadcrumbs %}
{% block breadcrumbs %}
  {{ block.super }}
  {% breadcrumb "Сотрудники кафедры" "/about-workers" %}
{% endblock %}
{% block content %}
  {% render_breadcrumbs %}
  <section class="container-fluid flex-grow">
    <h4>Преподаватели:</h4>
    <section class="teacher-cards" id="teacher-cards">
      <ul style="list-style: none">
        {% for teacher in teachers %}
          <li>
            <div class="card mb-3">
              <div class="row no-gutters">
                <div class="col-md-4">
                  <a href="{% url 'main:teacher'  teacher.id %}"><img src="
                        {% if  teacher.photo %}
                        {{ teacher.photo.url }}
                        {% else %}
      https://mdbootstrap.com/img/Photos/Others/placeholder-avatar.jpg
      {% endif %}" class="card-img" alt="..."></a>
                </div>
                <div class="col-md-8">
                  <div class="card-body">
                    <a href="{% url 'main:teacher' teacher.id %}"><h5
                        class="card-title">{{ teacher.last_name }} {{ teacher.first_name }} {{ teacher.middle_name }}</h5>
                    </a>
                    <p class="card-text">{{ teacher.position|default_if_none:'' }}<br>
                      {{ teacher.degree|default_if_none:'' }}<br>
                      {{ teacher.title|default_if_none:'' }}
                    </p>
                    <p class="card-text" hidden>
                      <small class="text-muted">Last updated 3 mins ago</small>
                    </p>
                  </div>
                </div>
              </div>
            </div>
          </li>
        {% endfor %}
      </ul>
    </section>
    {% if workers %}
      <h4>Учебно-вспомогательный персонал:</h4>
      <section class="teacher-cards" id="teacher-cards">
        <ul style="list-style: none">
          {% for worker in workers %}
            <li>
              <div class="card mb-3">
                <div class="row no-gutters">
                  <div class="col-md-4">
                    <a href="{% url 'main:worker'  worker.id %}"><img src="
                        {% if  worker.photo %}
                        {{ worker.photo.url }}
                        {% else %}
      https://mdbootstrap.com/img/Photos/Others/placeholder-avatar.jpg
      {% endif %}" class="card-img" alt="..."></a>
                  </div>
                  <div class="col-md-8">
                    <div class="card-body">
                      <a href="{% url 'main:worker' worker.id %}"><h5
                          class="card-title">{{ worker.last_name }} {{ worker.first_name }} {{ worker.middle_name }}</h5>
                      </a>
                      <p class="card-text">{{ worker.position|default_if_none:'' }}
                      </p>
                    </div>
                  </div>
                </div>
              </div>
            </li>
          {% endfor %}
        </ul>
      </section>
    {% endif %}
  </section>
{% endblock %}

django/main/templates/main/base.html
{% load static %}
{% load django_bootstrap_breadcrumbs %}
{% block breadcrumbs %}
  {% clear_breadcrumbs %}
  {% breadcrumb_safe "<i class='fas fa-home'></i>" "/" %}
{% endblock %}

<!doctype html>
<html lang="ru">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
  <link rel="stylesheet" href="{% static "main/npm/css/bootstrap.min.css" %}">
  <link rel="stylesheet" href="{% static "main/npm/css/all.min.css" %}">
  <link rel="stylesheet" href="{% static "main/css/base.css" %}">
  <link rel="stylesheet" href="{% static "main/css/Footer-Dark.css" %}">

  {% block css %}
    <link rel="stylesheet" href="{% static "main/css/main.css" %}">
  {% endblock %}
  <link rel="icon" href="{% static "main/images/ippo.ico" %}" type="image/x-icon">
  <title>{% block title %}Кафедра инструментального и прикладного программного обеспечения{% endblock %} -
    ИиППО</title>
</head>
<nav class="navbar navbar-expand-xl navbar-dark bg-dark">
  <a class="navbar-brand" id="logo" href="{% url "main:home" %}">
    <img src="{% static "main/images/ippo_i.png" %}" height=22 alt="ИиППО">
    ИиППО
  </a>
  <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarNav"
          aria-controls="navbarNav" aria-expanded="false" aria-label="Toggle navigation">
    <span class="navbar-toggler-icon"></span>
  </button>
  <div class="collapse navbar-collapse" id="navbarNav">
    <ul class="navbar-nav mr-auto">
      <li class="nav-item ">
        <a class="nav-link" href="{% url "appointment:index" %}">Электронная очередь</a>
      </li>
      <li class="nav-item dropdown">
        <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown" role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
          Библиотека работ
        </a>
        <div class="dropdown-menu" aria-labelledby="navbarDropdown">
          <a class="dropdown-item" href="{% url "diplomas:index" %}">Выпускные квалификационные работы</a>
          <a class="dropdown-item" href="{% url "library:index" %}">Практики</a>
        </div>
      </li>
      <li class="nav-item ">
        <a class="nav-link" href="{% url "schedule:index" %}">Расписание</a>
      </li>
      <li class="nav-item ">
        <a class="nav-link" href="http://ippo.it/documents/category/43">Итоговая аттестация</a>
      </li>
      <li class="nav-item ">
        <a class="nav-link" href="http://ippo.it/documents/category/60">Курсовое проектирование</a>
      </li>
      <li class="nav-item ">
        <a class="nav-link" href="http://ippo.it/documents/category/110">Практика</a>
      </li>
      <li class="nav-item ">
        <a class="nav-link" href="http://ippo.it/documents/category/1">Научная деятельность</a>
      </li>
      {#            <li class="nav-item ">#}
      {#                <a class="nav-link" href="{% url "main:about" %}">О кафедре</a>#}
      {#            </li>#}
      <!--<li class="nav-item ">
        <a class="nav-link" href="{% url "documents:index" %}">Документы</a>
      </li> -->
    </ul>
    <ul class="navbar-nav ml-auto">
      {% if user.is_authenticated %}
        <li><a class="nav-link" href="{% url 'people:profile' %}"
               role="button">{{ user.email }}</a></li>
        <li><a class="nav-link" href="/admin/logout/?next={% url 'main:home' %}"
               role="button"><i class="fas fa-sign-out-alt"></i></a></li>
      {% else %}
        <li><a class="nav-link" href="/admin/login/?next={% url 'main:home' %}"
               role="button"><i class="fas fa-sign-in-alt"></i></a>
        </li>
        {#            <li hidden><a class="nav-link" href="{% url 'people:register' %}"#}
        {#                   role="button"><i class="fas fa-user-plus"></i></a>#}
        {#            </li>#}
      {% endif %}
    </ul>
  </div>
</nav>
<body class="d-flex flex-column">
{% if messages %}
  {% for message in messages %}
    <div class="alert {{ message.tags }} alert-dismissible" role="alert">
      <button type="button" class="close" data-dismiss="alert" aria-label="Close">
        <span aria-hidden="true">&times;</span>
      </button>
      {{ message }}
    </div>
  {% endfor %}
{% endif %}

{% block content %}

{% endblock %}


<div class="footer-dark">
  <footer class="container">
    <div class="row">
      <div class="col-sm-6 col-md-6 item">
        {#        <h3>Services</h3>#}
        <ul>
          <li><a href="{% url "news:index" %}">Новости</a></li>
          <li><a href="{% url "subjects:index" %}">Дисциплины</a></li>
        </ul>
      </div>
      {#                <div class="col-sm-6 col-md-3 item">#}
      <div class="col-sm-6 col-md-6 item">
        {#        <h3>О кафедре</h3>#}
        <ul>
          <li><a href="/about-today">Кафедра сегодня</a></li>
          <li><a href="/about-history">История кафедры</a></li>
          <li><a href="/about-workers">Сотрудники кафедры</a></li>
          <li><a href="{% url "main:feedback" %}">Отправить отзыв</a></li>
        </ul>
      </div>
{#      <div class="col-md-6 item">#}
{#        <h3></h3>#}
{#        <ul>#}
{##}
{#        </ul>#}
{#      </div>#}
      <div class="col item social">
        <a href="https://vk.com/ippo_it"><i class="fab fa-vk"></i></a>
        <a href="https://t.me/IPPO_offical"><i class="fab fa-telegram-plane"></i></a>
      </div>
    </div>
{#    <p class="copyright">ИиППО {% now "Y" %}</p>#}
  </footer>
</div>

<script src="{% static "main/npm/js/jquery.min.js" %}"></script>
<script src="{% static "main/npm/js/bootstrap.bundle.min.js" %}"></script>
<script src="{% static "main/js/script.js" %}"></script>
{% block js %}
{% endblock %}
</body>
</html>

django/main/templates/main/feedback.html
{% extends 'main/base.html' %}
{% block title %}Отправить отзыв{% endblock %}
{% load django_bootstrap_breadcrumbs %}
{% block breadcrumbs %}
  {{ block.super }}
  {% breadcrumb 'Отправить отзыв' "main:feedback" %}
{% endblock %}
{% block content %}
  {% render_breadcrumbs %}
  <section class="container-fluid flex-grow">
    <div class="container">
      <div class="row">
        <div class="col">
          <form action="{% url "main:feedback" %}" method="post">
            {% csrf_token %}
            <div class="form-group">
              {{ form.subject.errors }}
              {{ form.subject.label_tag }}
              {{ form.subject }}
            </div>

            <div class="form-group">
              {{ form.message.errors }}
              {{ form.message.label_tag }}
              {{ form.message }}
            </div>

            <div class="form-group">
              {{ form.captcha }}
            </div>

            <button type="submit" class="btn btn-primary">Отправить</button>
          </form>
        </div>
      </div>
    </div>
  </section>
{% endblock %}

django/main/templates/main/index.html
{% extends 'main/base.html' %}
{% block content %}
  <section class="container-fluid flex-grow">
    <div class="container-fluid">
      <div class="row justify-content-center" style="padding-top: 15px">
        <div class="col-md-8 col-sm-12" id="news-cards" style="padding-bottom: 15px">
          {% if posts_list %}
              {% for post in posts_list %}
                <div class="card">
                  <div class="card-body">
                    <h6 class="card-subtitle mb-2 text-muted">{{ post.pub_date_time|date:'d.m.y' }}</h6>
                    {% if post.tags.all|length > 0 %}
                      {% for tag in post.tags.all %}
                        <a href="/news/tag/{{ tag.slug }}"
                           class="badge badge-success">{{ tag }}</a>
                      {% endfor %}
                    {% endif %}
                    <a href="{% url 'news:post' post.slug %}"><h4
                        class="card-title">{{ post.title }}</h4></a>
                  </div>
                </div>
              {% endfor %}
            <a class="btn btn-outline-primary" id="all-news" href="{% url "news:index" %}" role="button">Все
              новости</a>

          {% endif %}
        </div>
        <div class="col-md-4 col-sm-12">
          <script type="text/javascript" src="https://vk.com/js/api/openapi.js?162"></script>

          <!-- VK Widget -->
          <div id="vk_groups" style="width: auto"></div>
          <script type="text/javascript">
              VK.Widgets.Group("vk_groups", {mode: 4, wide: 1, height: "700", width: "auto"}, 189024421);
          </script>
        </div>
      </div>


    </div>
  </section>
{% endblock %}

django/main/templates/main/teacher.html
{% extends 'main/about_workers.html' %}
{% load static %}
{% block title %}{{ teacher.last_name }} {{ teacher.first_name }} {{ teacher.middle_name }}{% endblock %}
{% load django_bootstrap_breadcrumbs %}
{% block breadcrumbs %}
  {{ block.super }}
  {% breadcrumb teacher "main:teacher" teacher.id %}
{% endblock %}
{% block content %}
  {% render_breadcrumbs %}
  <section class="container-fluid flex-grow">
    <div class="container">
      <div class="row">
        <div class="col-md-6">
          <img src="{% if  teacher.photo %}
                  {{ teacher.photo.url }}
                  {% else %}
https://mdbootstrap.com/img/Photos/Others/placeholder-avatar.jpg
{% endif %}" class="card-img" alt="...">
        </div>
        <div class="col-md-6">
          <h5>{{ teacher.last_name }} {{ teacher.first_name }} {{ teacher.middle_name }}</h5>
          <p>{{ teacher.position|default_if_none:'' }}<br>
            {{ teacher.degree|default_if_none:'' }}<br>
            {{ teacher.title|default_if_none:'' }}
          </p>
          {% if user.teacher %}
            <p>{{ teacher.phone|default_if_none:'' }}</p>
          {% endif %}
          <p>
            <a href="mailto:{{ teacher.email|default_if_none:'' }}">{{ teacher.email|default_if_none:'' }}</a>
          </p>
          {% if perms.teacher.change_teacher %}
            <a href="/admin/people/teacher/{{ teacher.id }}/change/"><i class="far fa-edit"></i></a>
          {% endif %}
        </div>
      </div>
      <div class="row" style="padding-top: 1rem">
        <div class="col">
          <ul>
            {% for subject in teacher.subjects.all %}
              <li style="list-style: none"><a
                  href="{% url 'subjects:subject' subject.id %}">{{ subject }}</a></li>
            {% endfor %}
          </ul>
        </div>
      </div>
    </div>
  </section>
{% endblock %}

django/main/templates/main/worker.html
{% extends 'main/about_workers.html' %}
{% load static %}
{% block title %}{{ worker.last_name }} {{ worker.first_name }} {{ worker.middle_name }}{% endblock %}
{% load django_bootstrap_breadcrumbs %}
{% block breadcrumbs %}
  {{ block.super }}
  {% breadcrumb worker "main:worker" worker.id %}
{% endblock %}
{% block content %}
  {% render_breadcrumbs %}
  <section class="container-fluid flex-grow">
    <div class="container">
      <div class="row">
        <div class="col-md-6">
          <img src="{% if  worker.photo %}
                  {{ worker.photo.url }}
                  {% else %}
https://mdbootstrap.com/img/Photos/Others/placeholder-avatar.jpg
{% endif %}" class="card-img" alt="...">
        </div>
        <div class="col-md-6">
          <h5>{{ worker.last_name }} {{ worker.first_name }} {{ worker.middle_name }}</h5>
          <p>{{ worker.position|default_if_none:'' }}</p>
          <p><a href="mailto:{{ worker.email|default_if_none:'' }}">{{ worker.email|default_if_none:'' }}</a>
          </p>
          {% if perms.worker.change_worker %}
            <a href="/admin/people/worker/{{ worker.id }}/change/"><i class="far fa-edit"></i></a>
          {% endif %}
        </div>
      </div>
    </div>
  </section>
{% endblock %}